/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     AND = 258,
     AS = 259,
     CONST = 260,
     DEF = 261,
     DIV = 262,
     ELSE = 263,
     EXTERN = 264,
     IF = 265,
     IMPORT = 266,
     INCLUDE = 267,
     MOD = 268,
     NOT = 269,
     OR = 270,
     OTHERWISE = 271,
     PRIVATE = 272,
     PUBLIC = 273,
     SPECIAL = 274,
     THEN = 275,
     TYPE = 276,
     UNDEF = 277,
     VAR = 278,
     WHERE = 279,
     DOTDOT = 280,
     CAT = 281,
     DBAR = 282,
     LEQ = 283,
     GEQ = 284,
     NEQ = 285,
     STR = 286,
     UID = 287,
     LID = 288,
     QUID = 289,
     QLID = 290,
     STR1 = 291,
     INT = 292,
     FLOAT = 293,
     OP0 = 294,
     OP1 = 295,
     OP2 = 296,
     OP3 = 297,
     OP4 = 298,
     OP5 = 299,
     OP6 = 300,
     OP7 = 301,
     OP8 = 302,
     OP9 = 303,
     ERRTOK = 304,
     EOFTOK = 305
   };
#endif
#define AND 258
#define AS 259
#define CONST 260
#define DEF 261
#define DIV 262
#define ELSE 263
#define EXTERN 264
#define IF 265
#define IMPORT 266
#define INCLUDE 267
#define MOD 268
#define NOT 269
#define OR 270
#define OTHERWISE 271
#define PRIVATE 272
#define PUBLIC 273
#define SPECIAL 274
#define THEN 275
#define TYPE 276
#define UNDEF 277
#define VAR 278
#define WHERE 279
#define DOTDOT 280
#define CAT 281
#define DBAR 282
#define LEQ 283
#define GEQ 284
#define NEQ 285
#define STR 286
#define UID 287
#define LID 288
#define QUID 289
#define QLID 290
#define STR1 291
#define INT 292
#define FLOAT 293
#define OP0 294
#define OP1 295
#define OP2 296
#define OP3 297
#define OP4 298
#define OP5 299
#define OP6 300
#define OP7 301
#define OP8 302
#define OP9 303
#define ERRTOK 304
#define EOFTOK 305




/* Copy the first part of user declarations.  */
#line 2 "qc.y"


/* qc.y: yacc source of Q parser and Q compiler main program */

/* Special case constructs (unary minus, 1-tuples) cause a number of parsing
   conflicts which are resolved correctly. */

/*  Q eQuational Programming System
    Copyright (c) 1991-2002 by Albert Graef
    <ag@muwiinfa.geschichte.uni-mainz.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include "qcdefs.h"

int      	nerrs, nwarns;
bool		hflag, nflag, vflag, Vflag, wflag;
volatile bool   int_sig;
char           *self = "qc", *list = "";

char		signon[] = QC_SIGNON;
char   		usage[] = QC_USAGE;
char		opts[MAXSTRLEN];
char		copying[] = COPYING;
char		helpmsg[] = HELPMSG;

DECLARE_YYTEXT

extern int context;

static byte rhside;
static int type, fno_min, fno_max;
static byte flags, sflags;
static unsigned long argv;

static void start_qualifiers(void), qualifiers(void);
static void add_qualifier(EXPR *x);
static void start_where_clauses(void), end_where_clauses(void),
  add_where_clause(EXPR *l, EXPR *r);

static xvect_t *exprlist(void);
static xvect_t *addexpr(xvect_t *v, EXPR *x);
static EXPR *tupleexpr(xvect_t *v);
static EXPR *listexpr(xvect_t *v);


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 62 "qc.y"
typedef union YYSTYPE {
  int ival;
  mpz_t zval;
  double fval;
  char *sval;
  EXPR *xval;
  xvect_t *xvval;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 244 "qc.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 256 "qc.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1102

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  75
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  94
/* YYNRULES -- Number of rules. */
#define YYNRULES  272
/* YYNRULES -- Number of states. */
#define YYNSTATES  449

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   305

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    69,     2,    67,    64,     2,     2,    71,
      59,    60,    65,    54,    52,    55,    70,    66,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    56,    51,
      62,    57,    63,     2,    53,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    73,     2,    74,    68,     2,    72,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    58,     2,    61,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     4,     7,     8,    12,    16,    19,    22,
      25,    28,    31,    35,    38,    42,    44,    48,    51,    55,
      57,    61,    64,    68,    72,    73,    78,    83,    89,    90,
      97,    98,   106,   107,   114,   115,   123,   124,   127,   128,
     131,   132,   135,   137,   141,   142,   146,   148,   150,   153,
     154,   156,   158,   160,   162,   165,   167,   169,   171,   173,
     175,   176,   181,   184,   190,   194,   201,   202,   205,   209,
     210,   213,   218,   219,   222,   226,   230,   232,   236,   237,
     238,   244,   246,   250,   252,   253,   258,   259,   264,   265,
     272,   273,   276,   279,   282,   284,   285,   289,   291,   295,
     296,   301,   303,   307,   309,   313,   315,   319,   321,   323,
     325,   327,   329,   331,   333,   337,   339,   341,   343,   347,
     349,   351,   353,   357,   359,   361,   363,   365,   367,   369,
     371,   373,   377,   381,   383,   385,   387,   390,   392,   394,
     398,   400,   402,   404,   406,   408,   411,   413,   415,   418,
     421,   424,   427,   429,   431,   433,   435,   439,   441,   443,
     445,   447,   451,   453,   455,   457,   460,   462,   464,   466,
     468,   470,   472,   474,   478,   480,   482,   484,   488,   491,
     496,   501,   506,   511,   516,   521,   526,   531,   536,   541,
     546,   551,   556,   561,   566,   569,   573,   578,   584,   590,
     597,   605,   608,   612,   617,   623,   629,   631,   635,   637,
     639,   641,   643,   645,   647,   649,   651,   653,   655,   657,
     659,   662,   664,   666,   668,   670,   672,   675,   677,   679,
     681,   683,   685,   687,   689,   691,   693,   695,   697,   699,
     701,   703,   705,   707,   709,   711,   713,   715,   717,   719,
     721,   723,   725,   727,   729,   731,   733,   735,   737,   739,
     741,   742,   743,   747,   751,   755,   759,   763,   767,   771,
     775,   779,   783
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short yyrhs[] =
{
      76,     0,    -1,    -1,    77,    78,    -1,    -1,    78,    79,
      51,    -1,    78,    81,    51,    -1,    78,    83,    -1,    78,
      84,    -1,    78,   107,    -1,    78,   114,    -1,    78,    50,
      -1,    78,     1,    51,    -1,    11,    80,    -1,    79,    52,
      80,    -1,    36,    -1,    36,     4,    36,    -1,    12,    82,
      -1,    81,    52,    82,    -1,    36,    -1,    36,     4,    36,
      -1,    53,    37,    -1,    53,    54,    37,    -1,    53,    55,
      37,    -1,    -1,    96,    85,   101,    51,    -1,    21,   168,
      90,    51,    -1,    98,    21,   168,    90,    51,    -1,    -1,
      21,   167,    91,    86,    92,    51,    -1,    -1,    98,    21,
     167,    91,    87,    92,    51,    -1,    -1,     9,    21,   167,
      91,    88,    51,    -1,    -1,    98,     9,    21,   167,    91,
      89,    51,    -1,    -1,     4,   167,    -1,    -1,    56,   166,
      -1,    -1,    57,    93,    -1,    94,    -1,    93,    58,    94,
      -1,    -1,    95,    97,   101,    -1,    98,    -1,    99,    -1,
      98,    99,    -1,    -1,    96,    -1,    17,    -1,    18,    -1,
     100,    -1,    99,   100,    -1,     5,    -1,    19,    -1,     9,
      -1,    23,    -1,   103,    -1,    -1,   101,    52,   102,   103,
      -1,   153,   104,    -1,    59,   164,    60,   104,   105,    -1,
     154,   104,   106,    -1,    59,   165,    60,   104,   105,   106,
      -1,    -1,   104,    32,    -1,   104,    61,    32,    -1,    -1,
      53,    37,    -1,    53,    59,   151,    60,    -1,    -1,     4,
     153,    -1,     6,   108,    51,    -1,    22,   112,    51,    -1,
     109,    -1,   108,    52,   109,    -1,    -1,    -1,   110,   126,
      57,   111,   126,    -1,   113,    -1,   112,    52,   113,    -1,
     152,    -1,    -1,   126,   115,    57,   116,    -1,    -1,   117,
     126,   119,    51,    -1,    -1,   116,    57,   118,   126,   119,
      51,    -1,    -1,   119,   120,    -1,   119,   121,    -1,    10,
     130,    -1,    16,    -1,    -1,    24,   122,   123,    -1,   124,
      -1,   123,    52,   124,    -1,    -1,   126,    57,   125,   126,
      -1,   127,    -1,   126,   131,   127,    -1,   128,    -1,   128,
     133,   127,    -1,   136,    -1,   136,   129,   136,    -1,    62,
      -1,    63,    -1,    28,    -1,    29,    -1,    30,    -1,    41,
      -1,   132,    -1,   130,   131,   132,    -1,    27,    -1,    39,
      -1,   134,    -1,   134,   133,   132,    -1,    64,    -1,    40,
      -1,   136,    -1,   136,   135,   136,    -1,    62,    -1,    63,
      -1,    57,    -1,    28,    -1,    29,    -1,    30,    -1,    41,
      -1,   138,    -1,   136,   137,   138,    -1,   136,    55,   138,
      -1,    54,    -1,    26,    -1,    15,    -1,    15,     8,    -1,
      42,    -1,   140,    -1,   138,   139,   140,    -1,    65,    -1,
      66,    -1,     7,    -1,    13,    -1,     3,    -1,     3,    20,
      -1,    43,    -1,   142,    -1,    55,    37,    -1,    55,    38,
      -1,    55,   140,    -1,   141,   140,    -1,    67,    -1,    14,
      -1,    44,    -1,   144,    -1,   144,   143,   142,    -1,    68,
      -1,    69,    -1,    45,    -1,   146,    -1,   144,   145,   146,
      -1,    70,    -1,    46,    -1,   148,    -1,   146,   148,    -1,
      71,    -1,    72,    -1,    61,    -1,    48,    -1,    37,    -1,
      38,    -1,    31,    -1,    59,   151,    60,    -1,   155,    -1,
     161,    -1,   158,    -1,   158,    56,   166,    -1,   147,   148,
      -1,    59,   130,   131,    60,    -1,    59,   131,   132,    60,
      -1,    59,   134,   133,    60,    -1,    59,   133,   132,    60,
      -1,    59,   136,   135,    60,    -1,    59,   135,   136,    60,
      -1,    59,   136,   137,    60,    -1,    59,   136,    55,    60,
      -1,    59,   137,   138,    60,    -1,    59,   138,   139,    60,
      -1,    59,   139,   140,    60,    -1,    59,   144,   143,    60,
      -1,    59,   143,   142,    60,    -1,    59,   144,   145,    60,
      -1,    59,   145,   146,    60,    -1,    59,    60,    -1,    59,
     130,    60,    -1,    59,   130,    52,    60,    -1,    59,   130,
      58,   130,    60,    -1,    59,   130,    52,   149,    60,    -1,
      59,   130,    52,   149,    52,    60,    -1,    59,   130,    52,
     149,    58,   130,    60,    -1,    73,    74,    -1,    73,   149,
      74,    -1,    73,   149,    52,    74,    -1,    73,   149,    58,
     130,    74,    -1,    73,   149,    25,   130,    74,    -1,   130,
      -1,   149,    52,   130,    -1,    27,    -1,    64,    -1,    62,
      -1,    63,    -1,    57,    -1,    28,    -1,    29,    -1,    30,
      -1,    26,    -1,    54,    -1,    55,    -1,    15,    -1,    15,
       8,    -1,    65,    -1,    66,    -1,     7,    -1,    13,    -1,
       3,    -1,     3,    20,    -1,    67,    -1,    14,    -1,    71,
      -1,    72,    -1,    61,    -1,    68,    -1,    69,    -1,    70,
      -1,   150,    -1,    39,    -1,    40,    -1,    41,    -1,    42,
      -1,    43,    -1,    44,    -1,    45,    -1,    46,    -1,    48,
      -1,   155,    -1,   159,    -1,   156,    -1,   160,    -1,   157,
      -1,   161,    -1,    33,    -1,    35,    -1,    33,    -1,    35,
      -1,    32,    -1,    32,    -1,    34,    -1,    32,    -1,    34,
      -1,    -1,    -1,   162,   156,   163,    -1,   162,   157,   163,
      -1,   162,   150,   163,    -1,   162,    32,   163,    -1,   162,
      33,   163,    -1,   162,    34,   163,    -1,   162,    35,   163,
      -1,   162,    32,   163,    -1,   162,    33,   163,    -1,   162,
      34,   163,    -1,   162,    35,   163,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   108,   108,   108,   112,   113,   115,   117,   119,   121,
     123,   125,   132,   136,   137,   140,   142,   146,   147,   150,
     152,   156,   158,   160,   166,   165,   168,   174,   181,   180,
     198,   197,   214,   213,   218,   217,   224,   225,   230,   231,
     235,   236,   239,   240,   243,   243,   247,   248,   249,   252,
     253,   256,   258,   262,   263,   266,   268,   270,   272,   276,
     277,   277,   280,   295,   309,   330,   351,   352,   361,   370,
     371,   373,   385,   386,   390,   391,   394,   395,   398,   400,
     398,   405,   406,   409,   422,   421,   427,   427,   431,   430,
     436,   437,   439,   442,   444,   449,   448,   454,   455,   459,
     458,   464,   465,   469,   470,   474,   475,   479,   480,   481,
     482,   483,   484,   487,   488,   492,   493,   496,   497,   501,
     502,   505,   506,   510,   511,   512,   513,   514,   515,   516,
     519,   520,   522,   526,   527,   528,   529,   530,   533,   534,
     538,   539,   540,   541,   542,   543,   544,   549,   550,   551,
     552,   553,   556,   557,   558,   561,   562,   566,   567,   568,
     571,   572,   576,   577,   580,   581,   585,   586,   587,   588,
     594,   595,   596,   600,   601,   602,   603,   605,   618,   623,
     626,   631,   634,   639,   642,   647,   650,   653,   658,   661,
     666,   669,   674,   677,   684,   694,   696,   698,   700,   703,
     706,   712,   714,   717,   720,   722,   728,   730,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,   747,   748,   749,   750,   751,   752,   753,   754,   755,
     756,   757,   758,   759,   760,   763,   764,   765,   766,   767,
     768,   769,   770,   771,   772,   775,   776,   779,   780,   783,
     784,   787,   789,   793,   797,   801,   805,   807,   811,   815,
     819,   822,   825,   829,   831,   835,   837,   839,   841,   845,
     847,   851,   853
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "AND", "AS", "CONST", "DEF", "DIV", "ELSE", 
  "EXTERN", "IF", "IMPORT", "INCLUDE", "MOD", "NOT", "OR", "OTHERWISE", 
  "PRIVATE", "PUBLIC", "SPECIAL", "THEN", "TYPE", "UNDEF", "VAR", "WHERE", 
  "DOTDOT", "CAT", "DBAR", "LEQ", "GEQ", "NEQ", "STR", "UID", "LID", 
  "QUID", "QLID", "STR1", "INT", "FLOAT", "OP0", "OP1", "OP2", "OP3", 
  "OP4", "OP5", "OP6", "OP7", "OP8", "OP9", "ERRTOK", "EOFTOK", "';'", 
  "','", "'@'", "'+'", "'-'", "':'", "'='", "'|'", "'('", "')'", "'~'", 
  "'<'", "'>'", "'$'", "'*'", "'/'", "'#'", "'^'", "'!'", "'.'", "'''", 
  "'`'", "'['", "']'", "$accept", "source", "@1", "program", "imports", 
  "import", "includes", "include", "priority", "declaration", "@2", "@3", 
  "@4", "@5", "@6", "type_alias", "opt_type", "opt_header_sects", 
  "header_sects", "header_sect", "@7", "prefix", "opt_prefix", "scope", 
  "modifiers", "modifier", "headers", "@8", "header", "vid_list", 
  "id_prec", "id_alias", "definition", "defs", "def", "@9", "@10", 
  "undefs", "undef", "rule", "@11", "body", "@12", "@13", "qualifiers", 
  "condition", "where", "@14", "where_clauses", "where_clause", "@15", 
  "lexpression", "lrightapp", "lrelation", "lrelop", "expression", 
  "seqop", "rightapp", "rappop", "relation", "relop", "addition", "addop", 
  "multiplication", "mulop", "unary", "unop", "script", "scriptop", 
  "composition", "compop", "application", "quoteop", "primary", 
  "expr_list", "builtin_op", "op", "id", "nid", "qid", "fid", "nfid", 
  "qfid", "vid", "fvid", "nfvid", "qfvid", "c_on", "c_off", "nfid_or_op", 
  "qfid_or_op", "tid", "ntid", "qtid", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,    59,    44,    64,    43,    45,    58,    61,   124,    40,
      41,   126,    60,    62,    36,    42,    47,    35,    94,    33,
      46,    39,    96,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    75,    77,    76,    78,    78,    78,    78,    78,    78,
      78,    78,    78,    79,    79,    80,    80,    81,    81,    82,
      82,    83,    83,    83,    85,    84,    84,    84,    86,    84,
      87,    84,    88,    84,    89,    84,    90,    90,    91,    91,
      92,    92,    93,    93,    95,    94,    96,    96,    96,    97,
      97,    98,    98,    99,    99,   100,   100,   100,   100,   101,
     102,   101,   103,   103,   103,   103,   104,   104,   104,   105,
     105,   105,   106,   106,   107,   107,   108,   108,   110,   111,
     109,   112,   112,   113,   115,   114,   117,   116,   118,   116,
     119,   119,   119,   120,   120,   122,   121,   123,   123,   125,
     124,   126,   126,   127,   127,   128,   128,   129,   129,   129,
     129,   129,   129,   130,   130,   131,   131,   132,   132,   133,
     133,   134,   134,   135,   135,   135,   135,   135,   135,   135,
     136,   136,   136,   137,   137,   137,   137,   137,   138,   138,
     139,   139,   139,   139,   139,   139,   139,   140,   140,   140,
     140,   140,   141,   141,   141,   142,   142,   143,   143,   143,
     144,   144,   145,   145,   146,   146,   147,   147,   147,   147,
     148,   148,   148,   148,   148,   148,   148,   148,   148,   148,
     148,   148,   148,   148,   148,   148,   148,   148,   148,   148,
     148,   148,   148,   148,   148,   148,   148,   148,   148,   148,
     148,   148,   148,   148,   148,   148,   149,   149,   150,   150,
     150,   150,   150,   150,   150,   150,   150,   150,   150,   150,
     150,   150,   150,   150,   150,   150,   150,   150,   150,   150,
     150,   150,   150,   150,   150,   151,   151,   151,   151,   151,
     151,   151,   151,   151,   151,   152,   152,   153,   153,   154,
     154,   155,   155,   156,   157,   158,   159,   159,   160,   161,
     162,   163,   164,   165,   165,   166,   166,   166,   166,   167,
     167,   168,   168
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     2,     0,     3,     3,     2,     2,     2,
       2,     2,     3,     2,     3,     1,     3,     2,     3,     1,
       3,     2,     3,     3,     0,     4,     4,     5,     0,     6,
       0,     7,     0,     6,     0,     7,     0,     2,     0,     2,
       0,     2,     1,     3,     0,     3,     1,     1,     2,     0,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       0,     4,     2,     5,     3,     6,     0,     2,     3,     0,
       2,     4,     0,     2,     3,     3,     1,     3,     0,     0,
       5,     1,     3,     1,     0,     4,     0,     4,     0,     6,
       0,     2,     2,     2,     1,     0,     3,     1,     3,     0,
       4,     1,     3,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     1,     1,     3,     1,
       1,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     1,     1,     1,     2,     1,     1,     3,
       1,     1,     1,     1,     1,     2,     1,     1,     2,     2,
       2,     2,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     3,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     1,     1,     3,     2,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     2,     3,     4,     5,     5,     6,
       7,     2,     3,     4,     5,     5,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     0,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned short yydefact[] =
{
       2,     0,     4,     1,     0,     0,    55,    78,    57,     0,
       0,   153,    51,    52,    56,   260,     0,    58,   172,   255,
     251,   259,   252,   170,   171,   154,   169,    11,     0,     0,
       0,   168,   152,   166,   167,     0,     0,     0,     7,     8,
      24,    46,    47,    53,     9,    10,    84,   101,   103,   105,
     130,   138,     0,   147,   155,   160,     0,   164,   174,   176,
     175,    12,     0,    76,     0,   260,    15,    13,    19,    17,
       0,    38,    36,   256,   257,     0,    81,    83,   245,   246,
      21,     0,     0,   148,   149,   150,   144,   142,   143,   153,
     135,   134,   115,   126,   127,   128,   116,   120,   129,   137,
     146,   154,   159,   163,   169,   133,   218,   125,   194,   168,
     123,   124,   119,   140,   141,   152,   157,   158,   162,   166,
     167,     0,     0,   113,     0,   117,     0,   121,     0,   130,
       0,     0,   155,     0,   235,     0,   201,   206,   117,   121,
       0,     5,     0,     6,     0,     0,    57,   260,    48,    57,
      54,   115,   116,     0,     0,   120,   119,     0,   135,   134,
     109,   110,   111,   112,   137,   133,     0,   107,   108,     0,
       0,   144,   142,   143,   146,   140,   141,     0,   151,   159,
     163,   157,   158,   162,     0,     0,   165,   178,   260,    74,
      78,     0,     0,    38,     0,     0,   261,   261,   261,   261,
     260,    28,   260,     0,    75,     0,    22,    23,   145,   136,
       0,     0,   195,     0,     0,     0,     0,     0,   126,   127,
     128,   129,     0,   125,   123,   124,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   173,     0,     0,     0,     0,
       0,     0,   202,    14,    18,   258,   253,   254,   260,     0,
      59,    66,    66,   247,   249,   248,   250,   260,    38,    36,
      86,   102,   104,   136,   132,   106,   131,   145,   139,   156,
     161,     0,   177,    77,    79,    32,    16,    20,   269,   270,
     271,   272,    39,    40,    37,    26,    82,   196,     0,     0,
     179,   114,   180,   182,   181,   118,   184,   186,   183,   122,
     185,   187,   188,   189,   191,   190,   192,   193,     0,   203,
     207,     0,     0,     0,     0,    25,    60,    62,    72,    38,
      30,     0,    85,     0,   261,   261,   261,   261,     0,     0,
      44,     0,     0,     0,   198,   197,   205,   204,   225,   223,
     224,   228,   219,   216,   208,   213,   214,   215,   217,   218,
     212,   231,   210,   211,   209,   221,   222,   227,   232,   233,
     234,   229,   230,   261,   261,   261,    66,    66,     0,    67,
       0,     0,    64,    34,    40,    27,    88,    90,   265,   266,
     267,   268,    80,    33,    41,    42,    49,    29,   199,     0,
     226,   220,   264,   262,   263,    69,    69,    61,    68,    73,
       0,     0,     0,     0,    44,    50,     0,    46,   200,     0,
      63,    72,    35,    31,    90,     0,    94,    95,    87,    91,
      92,    43,    45,    70,     0,    65,     0,    93,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,    89,
      96,    97,     0,    71,     0,    99,    98,     0,   100
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     1,     2,     4,    36,    67,    37,    69,    38,    39,
     145,   283,   374,   329,   400,   203,   201,   331,   384,   385,
     386,    40,   406,    41,    42,    43,   249,   368,   250,   317,
     410,   372,    44,    62,    63,    64,   328,    75,    76,    45,
     153,   322,   323,   402,   403,   419,   420,   428,   440,   441,
     447,   442,    47,    48,   169,   137,   154,   123,   124,   138,
     126,   139,   170,    50,   177,    51,    52,    53,   131,    54,
     133,    55,    56,    57,   140,   134,   135,    77,   251,   252,
      58,   253,   254,    59,    79,   255,    60,   192,   278,   313,
     314,   272,    71,    72
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -241
static const short yypact[] =
{
    -241,    62,  -241,  -241,   242,    -5,  -241,  -241,   128,   100,
     116,  -241,  -241,  -241,  -241,  -241,   197,  -241,  -241,  -241,
    -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,   108,   811,
     419,  -241,  -241,  -241,  -241,   532,    46,    81,  -241,  -241,
    -241,   289,    82,  -241,  -241,  -241,    28,  -241,    66,   876,
      38,  -241,   842,  -241,   200,  1029,  1029,  -241,  -241,   102,
    -241,  -241,   115,  -241,   842,  -241,   171,  -241,   174,  -241,
     298,   134,   180,  -241,  -241,   119,  -241,  -241,  -241,  -241,
    -241,   161,   184,   909,   927,  -241,    20,     4,   164,   165,
      16,   166,   176,   177,   178,   181,   189,   190,   192,   195,
     198,   207,   211,   212,   218,   222,   811,   225,  -241,   227,
     228,   229,   231,   233,   236,   239,   240,   246,   247,   251,
     256,   175,   842,  -241,   842,    66,   842,   131,   842,    38,
     842,  1029,   200,  1029,  -241,   258,  -241,    28,    66,   866,
      11,  -241,   100,  -241,   116,   185,   219,  -241,    82,  -241,
    -241,  -241,  -241,   245,   842,  -241,  -241,   842,   249,  -241,
    -241,  -241,  -241,  -241,  -241,  -241,   842,  -241,  -241,   842,
     842,   303,  -241,  -241,  -241,  -241,  -241,   842,  -241,  -241,
    -241,  -241,  -241,  -241,  1029,  1029,  -241,  -241,  -241,  -241,
    -241,    43,    85,   134,   286,   290,  -241,  -241,  -241,  -241,
    -241,  -241,  -241,   287,  -241,   197,  -241,  -241,   279,   285,
     358,   842,  -241,   594,   288,   291,   625,   114,  -241,  -241,
    -241,  -241,   656,  -241,  -241,  -241,   687,   718,    30,   749,
     292,   293,   970,   978,  1021,  -241,   842,   842,   842,   842,
     563,   842,  -241,  -241,  -241,  -241,  -241,  -241,  -241,   149,
    -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,   134,   180,
    -241,  -241,  -241,  -241,    38,   122,    38,  -241,  -241,  -241,
    1029,   302,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,
    -241,  -241,  -241,   297,  -241,  -241,  -241,  -241,   137,     8,
    -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,   122,
    -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,     0,  -241,
      28,     5,   314,   295,   296,  -241,  -241,   -11,    27,   134,
    -241,   299,   300,   842,  -241,  -241,  -241,  -241,   842,   307,
    -241,   308,   780,   842,  -241,  -241,  -241,  -241,   326,  -241,
    -241,  -241,   352,  -241,  -241,  -241,  -241,  -241,  -241,  -241,
    -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,
    -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,   185,  -241,
     329,   183,  -241,  -241,   297,  -241,  -241,    28,  -241,  -241,
    -241,  -241,    28,  -241,   305,  -241,   187,  -241,  -241,    26,
    -241,  -241,  -241,  -241,  -241,    60,    60,  -241,  -241,  -241,
     313,   315,   842,    32,  -241,  -241,   185,    82,  -241,    12,
    -241,   361,  -241,  -241,    28,   842,  -241,  -241,  -241,  -241,
    -241,  -241,   321,  -241,   490,  -241,    42,    28,   842,  -241,
    -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,   328,  -241,
     322,  -241,    50,  -241,   842,  -241,  -241,   842,    28
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -241,  -241,  -241,  -241,  -241,   252,  -241,   223,  -241,  -241,
    -241,  -241,  -241,  -241,  -241,   138,  -180,    29,  -241,     1,
    -241,    15,  -241,    18,   -37,   -24,     2,  -241,    39,  -240,
      13,     3,  -241,  -241,   220,  -241,  -241,  -241,   206,  -241,
    -241,  -241,  -241,  -241,     6,  -241,  -241,  -241,  -241,   -32,
    -241,    -3,  -100,  -241,  -241,   -28,   -27,  -102,   -23,   385,
      -8,    -4,    -2,   -19,    -1,   -22,  -241,  -112,   -20,   386,
     -16,  -110,  -241,   -47,   213,   109,    14,  -241,    56,  -241,
      -6,   123,   124,  -241,  -241,  -241,  -140,    -9,  -183,  -241,
    -241,   237,   -48,   281
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -245
static const short yytable[] =
{
      49,    46,   121,   122,   148,   256,    70,    85,   186,   187,
      78,   129,   318,   275,   279,   280,   281,   193,   150,   231,
     214,   369,   215,   234,   209,   157,   127,   151,   128,   130,
     178,   371,   151,   171,   184,   151,   239,   172,   185,   152,
     208,   171,   415,   173,   152,   172,    61,   152,   416,   423,
     370,   173,   415,   151,   261,   151,   417,   262,   416,   369,
      49,   191,     3,   240,  -223,   152,   417,   152,   335,   241,
     151,   424,   269,   174,   336,   270,  -219,   151,   320,   337,
    -225,   174,   152,   418,    85,   242,   408,     6,   370,   152,
     301,   149,   369,   439,   213,   175,   176,   141,   142,   258,
     274,    14,   216,   175,   176,    17,   155,   445,   230,   228,
     236,   291,   232,   409,   295,   237,   233,   196,   197,   226,
     269,   370,   217,   270,   150,   227,   395,   396,   229,   158,
     156,   238,   143,   144,   291,   295,    66,   158,    70,   373,
     159,   378,   379,   380,   381,    80,   158,   264,   159,    65,
      49,   266,    68,    49,   284,   268,   164,   159,   188,   218,
     219,   220,    81,    82,   164,   265,   189,   190,   165,   166,
     204,   205,   221,   164,   296,   194,   165,   166,   195,   271,
     392,   393,   394,   289,   202,   165,   222,   186,   223,   332,
     200,   271,     6,   224,   225,   333,   149,   334,   206,    78,
     315,   316,   151,   264,    12,    13,    14,   268,   266,   319,
      17,   308,   310,   311,   152,   245,   246,   245,   246,    21,
     247,   207,   299,   186,  -224,  -228,  -216,   210,   256,    73,
      20,    74,    22,   211,   299,   212,  -208,  -213,  -214,   312,
     257,  -215,    -3,     5,   248,   179,   180,     6,     7,  -236,
    -237,     8,  -238,     9,    10,  -239,    11,   263,  -240,    12,
      13,    14,   236,    15,    16,    17,   256,  -241,   181,   182,
     183,  -242,  -243,    18,    19,    20,    21,    22,  -244,    23,
      24,   236,  -217,   236,   236,  -212,    25,  -231,  -210,  -211,
      26,  -209,    27,  -221,     6,    28,  -222,    29,   146,  -227,
    -232,    30,   260,    31,   310,   389,  -233,  -234,    14,    32,
     147,  -229,    17,    33,    34,    35,  -230,   338,   235,    49,
     377,   339,   276,   267,    49,   382,   277,   340,   341,   342,
     196,   197,   198,   199,   324,   325,   326,   327,   285,  -226,
     343,   344,   345,   346,   347,  -220,   390,   246,   292,   247,
     375,   293,   303,   304,   330,   366,   367,   376,   383,   387,
     391,   398,   236,   404,   412,   371,   413,   244,   348,   349,
     148,   350,    11,   316,   444,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   427,   443,    18,
      19,    20,    21,    22,   243,    23,    24,   321,    49,   414,
     236,   405,    25,   401,   407,   421,    26,   397,   422,   411,
     273,   286,   446,    29,   425,   125,   132,    30,   287,    31,
     426,   363,    86,   288,    49,    32,    87,   399,   259,    33,
      34,    35,    88,    89,    90,   364,   365,   282,   438,     0,
      49,     0,     0,    49,   448,    91,    92,    93,    94,    95,
      18,    19,    20,    21,    22,     0,    23,    24,    96,    97,
      98,    99,   100,   101,   102,   103,     0,   104,     0,     0,
       0,     0,     0,   105,   106,     0,   107,     0,    30,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,    35,   338,     0,     0,     0,   339,     0,     0,
       0,     0,     0,   340,   341,   342,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   343,   344,   345,   346,
     347,     0,     0,     0,     0,     0,     0,     0,     0,   429,
     430,   431,   432,   433,   434,   435,   436,     0,   437,     0,
       0,     0,     0,     0,   348,   349,    11,   350,     0,     0,
       0,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,    18,    19,    20,    21,    22,     0,    23,
      24,     0,     0,     0,     0,     0,    25,    11,     0,     0,
      26,     0,     0,     0,     0,     0,     0,    29,     0,     0,
       0,    30,     0,    31,    18,    19,    20,    21,    22,    32,
      23,    24,     0,    33,    34,    35,   136,    25,    11,     0,
       0,    26,     0,     0,     0,     0,     0,     0,    29,     0,
       0,     0,    30,     0,    31,    18,    19,    20,    21,    22,
      32,    23,    24,     0,    33,    34,    35,   309,    25,    11,
       0,     0,    26,     0,     0,     0,     0,     0,     0,    29,
       0,     0,     0,    30,   290,    31,    18,    19,    20,    21,
      22,    32,    23,    24,     0,    33,    34,    35,     0,    25,
      11,     0,     0,    26,     0,     0,     0,     0,     0,     0,
      29,     0,     0,     0,    30,   294,    31,    18,    19,    20,
      21,    22,    32,    23,    24,     0,    33,    34,    35,     0,
      25,    11,     0,     0,    26,     0,     0,     0,     0,     0,
       0,    29,     0,     0,     0,    30,   297,    31,    18,    19,
      20,    21,    22,    32,    23,    24,     0,    33,    34,    35,
       0,    25,    11,     0,     0,    26,     0,     0,     0,     0,
       0,     0,    29,     0,     0,     0,    30,   298,    31,    18,
      19,    20,    21,    22,    32,    23,    24,     0,    33,    34,
      35,     0,    25,    11,     0,     0,    26,     0,     0,     0,
       0,     0,     0,    29,     0,     0,     0,    30,   300,    31,
      18,    19,    20,    21,    22,    32,    23,    24,     0,    33,
      34,    35,     0,    25,    11,     0,     0,    26,     0,     0,
       0,     0,     0,     0,    29,     0,     0,     0,    30,   302,
      31,    18,    19,    20,    21,    22,    32,    23,    24,     0,
      33,    34,    35,     0,    25,    11,     0,     0,    26,     0,
       0,     0,     0,     0,     0,    29,     0,     0,     0,    30,
     388,    31,    18,    19,    20,    21,    22,    32,    83,    84,
       0,    33,    34,    35,     0,    25,    11,     0,     0,    26,
       0,     0,     0,     0,     0,     0,    29,     0,     0,     0,
      30,     0,    31,    18,    19,    20,    21,    22,    32,    23,
      24,   158,    33,    34,    35,     0,    25,     0,     0,     0,
      26,   158,   159,     0,   218,   219,   220,    29,     0,     0,
       0,    30,   159,    31,   160,   161,   162,   221,   164,    32,
       0,     0,     0,    33,    34,    35,     0,   163,   164,     0,
     165,   166,     0,   223,     0,     0,     0,     0,   224,   225,
     165,   166,     0,     0,     0,     0,     0,     0,   167,   168,
    -170,  -170,  -170,  -170,  -170,     0,  -170,  -170,     0,     0,
       0,     0,     0,     0,  -170,  -170,     0,  -170,  -171,  -171,
    -171,  -171,  -171,     0,  -171,  -171,     0,     0,  -170,     0,
    -170,     0,  -171,  -171,     0,  -171,     0,  -170,  -170,  -170,
    -170,  -170,  -170,     0,     0,     0,  -171,     0,  -171,     0,
       0,     0,     0,     0,     0,  -171,  -171,  -171,  -171,  -171,
    -171,    18,    19,    20,    21,    22,     0,    23,    24,    18,
      19,    20,    21,    22,     0,    23,    24,     0,    26,     0,
       0,     0,     0,     0,     0,     0,    26,     0,     0,    30,
     305,    31,     0,     0,     0,     0,     0,    30,   306,    31,
       0,    33,    34,    35,     0,     0,     0,     0,     0,    33,
      34,    35,    18,    19,    20,    21,    22,     0,    23,    24,
      18,    19,    20,    21,    22,     0,    23,    24,     0,    26,
       0,     0,     0,     0,     0,     0,     0,    26,     0,     0,
      30,   307,    31,     0,     0,     0,     0,     0,    30,     0,
      31,     0,    33,    34,    35,     0,     0,     0,     0,     0,
      33,    34,    35
};

static const short yycheck[] =
{
       4,     4,    30,    30,    41,   145,    15,    29,    55,    56,
      16,    30,   252,   193,   197,   198,   199,    65,    42,   131,
     122,    32,   124,   133,     8,    48,    30,    27,    30,    30,
      52,     4,    27,     3,    54,    27,    25,     7,    54,    39,
      20,     3,    10,    13,    39,     7,    51,    39,    16,    37,
      61,    13,    10,    27,   154,    27,    24,   157,    16,    32,
      64,    64,     0,    52,    60,    39,    24,    39,    60,    58,
      27,    59,   184,    43,    74,   185,    60,    27,   258,    74,
      60,    43,    39,    51,   106,    74,    60,     5,    61,    39,
      60,     9,    32,    51,   121,    65,    66,    51,    52,   147,
      57,    19,   125,    65,    66,    23,    40,    57,   130,   128,
     137,   213,   132,    53,   216,   138,   132,    32,    33,   127,
     232,    61,   126,   233,   148,   127,   366,   367,   129,    15,
      64,   139,    51,    52,   236,   237,    36,    15,   147,   319,
      26,   324,   325,   326,   327,    37,    15,   166,    26,    21,
     154,   170,    36,   157,   202,   177,    42,    26,    56,    28,
      29,    30,    54,    55,    42,   169,    51,    52,    54,    55,
      51,    52,    41,    42,    60,     4,    54,    55,     4,   188,
     363,   364,   365,   211,     4,    54,    55,   234,    57,    52,
      56,   200,     5,    62,    63,    58,     9,    60,    37,   205,
      51,    52,    27,   222,    17,    18,    19,   229,   227,   257,
      23,   239,   240,   241,    39,    32,    33,    32,    33,    34,
      35,    37,   226,   270,    60,    60,    60,    52,   368,    32,
      33,    34,    35,    58,   238,    60,    60,    60,    60,   248,
      21,    60,     0,     1,    59,    45,    46,     5,     6,    60,
      60,     9,    60,    11,    12,    60,    14,     8,    60,    17,
      18,    19,   289,    21,    22,    23,   406,    60,    68,    69,
      70,    60,    60,    31,    32,    33,    34,    35,    60,    37,
      38,   308,    60,   310,   311,    60,    44,    60,    60,    60,
      48,    60,    50,    60,     5,    53,    60,    55,     9,    60,
      60,    59,    57,    61,   332,   333,    60,    60,    19,    67,
      21,    60,    23,    71,    72,    73,    60,     3,    60,   323,
     323,     7,    36,    20,   328,   328,    36,    13,    14,    15,
      32,    33,    34,    35,    32,    33,    34,    35,    51,    60,
      26,    27,    28,    29,    30,    60,    20,    33,    60,    35,
      51,    60,    60,    60,    57,    60,    60,    57,    51,    51,
       8,    32,   389,    58,    51,     4,    51,   144,    54,    55,
     407,    57,    14,    52,    52,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,   415,    60,    31,
      32,    33,    34,    35,   142,    37,    38,   259,   402,   402,
     427,   386,    44,   374,   386,   404,    48,   368,   406,   396,
     190,   205,   444,    55,   411,    30,    30,    59,    60,    61,
     414,   312,     3,   210,   428,    67,     7,   371,   147,    71,
      72,    73,    13,    14,    15,   312,   312,   200,   424,    -1,
     444,    -1,    -1,   447,   447,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    -1,    -1,
      -1,    -1,    -1,    54,    55,    -1,    57,    -1,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,     3,    -1,    -1,    -1,     7,    -1,    -1,
      -1,    -1,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    26,    27,    28,    29,
      30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    -1,
      -1,    -1,    -1,    -1,    54,    55,    14,    57,    -1,    -1,
      -1,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    31,    32,    33,    34,    35,    -1,    37,
      38,    -1,    -1,    -1,    -1,    -1,    44,    14,    -1,    -1,
      48,    -1,    -1,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    59,    -1,    61,    31,    32,    33,    34,    35,    67,
      37,    38,    -1,    71,    72,    73,    74,    44,    14,    -1,
      -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    59,    -1,    61,    31,    32,    33,    34,    35,
      67,    37,    38,    -1,    71,    72,    73,    74,    44,    14,
      -1,    -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    59,    60,    61,    31,    32,    33,    34,
      35,    67,    37,    38,    -1,    71,    72,    73,    -1,    44,
      14,    -1,    -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    59,    60,    61,    31,    32,    33,
      34,    35,    67,    37,    38,    -1,    71,    72,    73,    -1,
      44,    14,    -1,    -1,    48,    -1,    -1,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    59,    60,    61,    31,    32,
      33,    34,    35,    67,    37,    38,    -1,    71,    72,    73,
      -1,    44,    14,    -1,    -1,    48,    -1,    -1,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    59,    60,    61,    31,
      32,    33,    34,    35,    67,    37,    38,    -1,    71,    72,
      73,    -1,    44,    14,    -1,    -1,    48,    -1,    -1,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    59,    60,    61,
      31,    32,    33,    34,    35,    67,    37,    38,    -1,    71,
      72,    73,    -1,    44,    14,    -1,    -1,    48,    -1,    -1,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    59,    60,
      61,    31,    32,    33,    34,    35,    67,    37,    38,    -1,
      71,    72,    73,    -1,    44,    14,    -1,    -1,    48,    -1,
      -1,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    59,
      60,    61,    31,    32,    33,    34,    35,    67,    37,    38,
      -1,    71,    72,    73,    -1,    44,    14,    -1,    -1,    48,
      -1,    -1,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      59,    -1,    61,    31,    32,    33,    34,    35,    67,    37,
      38,    15,    71,    72,    73,    -1,    44,    -1,    -1,    -1,
      48,    15,    26,    -1,    28,    29,    30,    55,    -1,    -1,
      -1,    59,    26,    61,    28,    29,    30,    41,    42,    67,
      -1,    -1,    -1,    71,    72,    73,    -1,    41,    42,    -1,
      54,    55,    -1,    57,    -1,    -1,    -1,    -1,    62,    63,
      54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    62,    63,
      31,    32,    33,    34,    35,    -1,    37,    38,    -1,    -1,
      -1,    -1,    -1,    -1,    45,    46,    -1,    48,    31,    32,
      33,    34,    35,    -1,    37,    38,    -1,    -1,    59,    -1,
      61,    -1,    45,    46,    -1,    48,    -1,    68,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    59,    -1,    61,    -1,
      -1,    -1,    -1,    -1,    -1,    68,    69,    70,    71,    72,
      73,    31,    32,    33,    34,    35,    -1,    37,    38,    31,
      32,    33,    34,    35,    -1,    37,    38,    -1,    48,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    48,    -1,    -1,    59,
      60,    61,    -1,    -1,    -1,    -1,    -1,    59,    60,    61,
      -1,    71,    72,    73,    -1,    -1,    -1,    -1,    -1,    71,
      72,    73,    31,    32,    33,    34,    35,    -1,    37,    38,
      31,    32,    33,    34,    35,    -1,    37,    38,    -1,    48,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    -1,    -1,
      59,    60,    61,    -1,    -1,    -1,    -1,    -1,    59,    -1,
      61,    -1,    71,    72,    73,    -1,    -1,    -1,    -1,    -1,
      71,    72,    73
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    76,    77,     0,    78,     1,     5,     6,     9,    11,
      12,    14,    17,    18,    19,    21,    22,    23,    31,    32,
      33,    34,    35,    37,    38,    44,    48,    50,    53,    55,
      59,    61,    67,    71,    72,    73,    79,    81,    83,    84,
      96,    98,    99,   100,   107,   114,   126,   127,   128,   136,
     138,   140,   141,   142,   144,   146,   147,   148,   155,   158,
     161,    51,   108,   109,   110,    21,    36,    80,    36,    82,
     162,   167,   168,    32,    34,   112,   113,   152,   155,   159,
      37,    54,    55,    37,    38,   140,     3,     7,    13,    14,
      15,    26,    27,    28,    29,    30,    39,    40,    41,    42,
      43,    44,    45,    46,    48,    54,    55,    57,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   143,   144,   145,   150,   151,    74,   130,   134,   136,
     149,    51,    52,    51,    52,    85,     9,    21,    99,     9,
     100,    27,    39,   115,   131,    40,    64,   133,    15,    26,
      28,    29,    30,    41,    42,    54,    55,    62,    63,   129,
     137,     3,     7,    13,    43,    65,    66,   139,   140,    45,
      46,    68,    69,    70,   143,   145,   148,   148,    56,    51,
      52,   126,   162,   167,     4,     4,    32,    33,    34,    35,
      56,    91,     4,    90,    51,    52,    37,    37,    20,     8,
      52,    58,    60,   131,   132,   132,   133,   136,    28,    29,
      30,    41,    55,    57,    62,    63,   135,   137,   138,   139,
     140,   142,   143,   145,   146,    60,   131,   133,   135,    25,
      52,    58,    74,    80,    82,    32,    33,    35,    59,   101,
     103,   153,   154,   156,   157,   160,   161,    21,   167,   168,
      57,   127,   127,     8,   138,   136,   138,    20,   140,   142,
     146,   162,   166,   109,    57,    91,    36,    36,   163,   163,
     163,   163,   166,    86,   167,    51,   113,    60,   149,   130,
      60,   132,    60,    60,    60,   132,    60,    60,    60,   136,
      60,    60,    60,    60,    60,    60,    60,    60,   130,    74,
     130,   130,   162,   164,   165,    51,    52,   104,   104,   167,
      91,    90,   116,   117,    32,    33,    34,    35,   111,    88,
      57,    92,    52,    58,    60,    60,    74,    74,     3,     7,
      13,    14,    15,    26,    27,    28,    29,    30,    54,    55,
      57,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   150,   156,   157,    60,    60,   102,    32,
      61,     4,   106,    91,    87,    51,    57,   126,   163,   163,
     163,   163,   126,    51,    93,    94,    95,    51,    60,   130,
      20,     8,   163,   163,   163,   104,   104,   103,    32,   153,
      89,    92,   118,   119,    58,    96,    97,    98,    60,    53,
     105,   105,    51,    51,   126,    10,    16,    24,    51,   120,
     121,    94,   101,    37,    59,   106,   119,   130,   122,    39,
      40,    41,    42,    43,    44,    45,    46,    48,   151,    51,
     123,   124,   126,    60,    52,    57,   124,   125,   126
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 108 "qc.y"
    { srcstate(); }
    break;

  case 5:
#line 114 "qc.y"
    { import(); newdecl(); }
    break;

  case 6:
#line 116 "qc.y"
    { include(); newdecl(); }
    break;

  case 7:
#line 118 "qc.y"
    { newdecl(); }
    break;

  case 8:
#line 120 "qc.y"
    { newdecl(); }
    break;

  case 9:
#line 122 "qc.y"
    { newrule(); }
    break;

  case 10:
#line 124 "qc.y"
    { newrule(); }
    break;

  case 12:
#line 133 "qc.y"
    { yyerrok; srcstate(); newrule(); newdecl(); }
    break;

  case 15:
#line 141 "qc.y"
    { add_import(yyvsp[0].sval, NULL); }
    break;

  case 16:
#line 143 "qc.y"
    { add_import(yyvsp[-2].sval, strdup(yyvsp[0].sval)); }
    break;

  case 19:
#line 151 "qc.y"
    { add_import(yyvsp[0].sval, NULL); }
    break;

  case 20:
#line 153 "qc.y"
    { add_import(yyvsp[-2].sval, strdup(yyvsp[0].sval)); }
    break;

  case 21:
#line 157 "qc.y"
    { priority(yyvsp[0].zval); mpz_clear(yyvsp[0].zval); }
    break;

  case 22:
#line 159 "qc.y"
    { priority(yyvsp[0].zval); mpz_clear(yyvsp[0].zval); }
    break;

  case 23:
#line 161 "qc.y"
    { mpz_neg(yyvsp[0].zval,yyvsp[0].zval);
				  priority(yyvsp[0].zval); mpz_clear(yyvsp[0].zval); }
    break;

  case 24:
#line 166 "qc.y"
    { type = 0; }
    break;

  case 26:
#line 169 "qc.y"
    { if (!(symtb[yyvsp[-2].ival].flags&DCL)) {
				    yyerror(qcmsg[AS_DCL_ERROR]);
				    YYERROR;
				  } else
				    astype(yyvsp[-2].ival, yyvsp[-1].ival, flags); }
    break;

  case 27:
#line 175 "qc.y"
    { if (!(symtb[yyvsp[-2].ival].flags&DCL)) {
				    yyerror(qcmsg[AS_DCL_ERROR]);
				    YYERROR;
				  } else
				    astype(yyvsp[-2].ival, yyvsp[-1].ival, flags); }
    break;

  case 28:
#line 181 "qc.y"
    { type = dcltype(yyvsp[-1].ival, yyvsp[0].ival, flags);
				  sflags = flags; fno_min = symtbsz; }
    break;

  case 29:
#line 184 "qc.y"
    { /* check for enumeration type */
				  int enumtype = 1, i;
				  fno_max = symtbsz-1;
				  for (i = fno_min; i <= fno_max; i++)
				    if (!(symtb[i].flags & CST) ||
					symtb[i].argc > 0) {
				      enumtype = 0; break;
				    }
				  if (enumtype) {
				    symtb[type].fno_min = fno_min;
				    symtb[type].fno_max = fno_max;
				  }
				}
    break;

  case 30:
#line 198 "qc.y"
    { type = dcltype(yyvsp[-1].ival, yyvsp[0].ival, flags);
				  sflags = flags; fno_min = symtbsz; }
    break;

  case 31:
#line 201 "qc.y"
    { int enumtype = 1, i;
				  fno_max = symtbsz-1;
				  for (i = fno_min; i <= fno_max; i++)
				    if (!(symtb[i].flags & CST) ||
					symtb[i].argc > 0) {
				      enumtype = 0; break;
				    }
				  if (enumtype) {
				    symtb[type].fno_min = fno_min;
				    symtb[type].fno_max = fno_max;
				  }
				}
    break;

  case 32:
#line 214 "qc.y"
    { type = dcltype(yyvsp[-1].ival, yyvsp[0].ival, flags|EXT);
				  sflags = flags; }
    break;

  case 34:
#line 218 "qc.y"
    { type = dcltype(yyvsp[-1].ival, yyvsp[0].ival, flags|EXT);
				  sflags = flags; }
    break;

  case 36:
#line 224 "qc.y"
    { yyval.ival = 0; }
    break;

  case 37:
#line 226 "qc.y"
    { yyval.ival = yyvsp[0].ival; }
    break;

  case 38:
#line 230 "qc.y"
    { yyval.ival = 0; }
    break;

  case 39:
#line 232 "qc.y"
    { yyval.ival = checktype(yyvsp[0].ival); }
    break;

  case 44:
#line 243 "qc.y"
    { flags = sflags; }
    break;

  case 51:
#line 257 "qc.y"
    { flags = PRIV; }
    break;

  case 52:
#line 259 "qc.y"
    { flags = 0; }
    break;

  case 55:
#line 267 "qc.y"
    { flags |= CST; }
    break;

  case 56:
#line 269 "qc.y"
    { flags |= SPEC; }
    break;

  case 57:
#line 271 "qc.y"
    { flags |= EXT; }
    break;

  case 58:
#line 273 "qc.y"
    { flags |= VSYM; }
    break;

  case 60:
#line 277 "qc.y"
    { argv = 0; }
    break;

  case 62:
#line 281 "qc.y"
    { if ((flags & VSYM) && (yyvsp[0].ival || type) ||
				      (flags & VSYM) && (flags & (EXT|SPEC)) ||
				      (flags & CST) && (flags & EXT) ||
				      !(flags & VSYM) &&
				      isupper(strsp[symtb[yyvsp[-1].ival].pname]) ||
				      (symtb[yyvsp[-1].ival].flags & DCL) &&
				      (symtb[yyvsp[-1].ival].flags & VSYM) !=
				      (flags & VSYM)) {
				    yyerror(qcmsg[DCL_ERROR]);
				    YYERROR;
				  } else if (flags & VSYM)
				    dclfvar(yyvsp[-1].ival, flags);
				  else
				    dclfun(yyvsp[-1].ival, type, yyvsp[0].ival, argv, flags, NONE); }
    break;

  case 63:
#line 296 "qc.y"
    { int prec = yyvsp[0].ival;
				  if (prec == NONE &&
				      (yyvsp[-3].ival < BUILTIN || symtb[yyvsp[-3].ival].modno == modno))
				    prec = symtb[yyvsp[-3].ival].prec;
				  if (prec == NONE) prec = 2;
				  if ((flags & VSYM) ||
				      (flags & CST) && (flags & EXT) ||
				      (prec == 5 || prec == 9) && yyvsp[-1].ival != 1 ||
				      (prec != 5 && prec != 9) && yyvsp[-1].ival != 2) {
				    yyerror(qcmsg[DCL_ERROR]);
				    YYERROR;
				  } else
				    dclfun(yyvsp[-3].ival, type, yyvsp[-1].ival, argv, flags, prec); }
    break;

  case 64:
#line 310 "qc.y"
    { if (!(symtb[yyvsp[-2].ival].flags&DCL)) {
				    yyerror(qcmsg[AS_DCL_ERROR]);
				    YYERROR;
				  } else if ((flags & VSYM) && (yyvsp[-1].ival || type) ||
					     (flags & VSYM) && (flags & (EXT|SPEC)) ||
					     (flags & CST) && (flags & EXT) ||
					     !(flags & VSYM) &&
					     isupper(strsp[symtb[yyvsp[-2].ival].pname]) ||
					     (symtb[yyvsp[-2].ival].flags & DCL) &&
					     (symtb[yyvsp[-2].ival].flags & VSYM) !=
					     (flags & VSYM) ||
					     type ||
					     yyvsp[0].ival && symtb[yyvsp[0].ival].modno == modno &&
					     (symtb[yyvsp[0].ival].flags&DCL)) {
				    yyerror(qcmsg[DCL_ERROR]);
				    YYERROR;
				  } else if (flags & VSYM)
				    asfvar(yyvsp[-2].ival, yyvsp[0].ival, flags);
				  else
				    asfun(yyvsp[-2].ival, yyvsp[0].ival, yyvsp[-1].ival, argv, flags, NONE); }
    break;

  case 65:
#line 331 "qc.y"
    { int prec = yyvsp[-1].ival;
				  if (prec == NONE) prec = symtb[yyvsp[-4].ival].prec;
				  if (!(symtb[yyvsp[-4].ival].flags&DCL)) {
				    yyerror(qcmsg[AS_DCL_ERROR]);
				    YYERROR;
				  } else if ((flags & VSYM) ||
					     (flags & CST) && (flags & EXT) ||
					     type ||
					     yyvsp[0].ival && symtb[yyvsp[0].ival].modno == modno &&
					     (symtb[yyvsp[0].ival].flags&DCL) ||
					     prec == NONE ||
					     (prec == 5 || prec == 9) && yyvsp[-2].ival != 1 ||
					     (prec != 5 && prec != 9) && yyvsp[-2].ival != 2) {
				    yyerror(qcmsg[DCL_ERROR]);
				    YYERROR;
				  } else
				    asfun(yyvsp[-4].ival, yyvsp[0].ival, yyvsp[-2].ival, argv, flags, prec); }
    break;

  case 66:
#line 351 "qc.y"
    { yyval.ival = 0; }
    break;

  case 67:
#line 353 "qc.y"
    { if (flags & SPEC)
				    if (yyvsp[-1].ival < sizeof(unsigned long)*8)
				      argv |= 1<<yyvsp[-1].ival;
				    else {
				      yyerror(qcmsg[DCL_ERROR]);
				      YYERROR;
				    }
				  yyval.ival = yyvsp[-1].ival+1; }
    break;

  case 68:
#line 362 "qc.y"
    { if (!(flags & SPEC)) {
				    yyerror(qcmsg[DCL_ERROR]);
				    YYERROR;
				  }
				  yyval.ival = yyvsp[-2].ival+1; }
    break;

  case 69:
#line 370 "qc.y"
    { yyval.ival = NONE; }
    break;

  case 70:
#line 372 "qc.y"
    { yyval.ival = precval(yyvsp[0].zval); }
    break;

  case 71:
#line 374 "qc.y"
    { int prec = symtb[yyvsp[-1].ival].prec;
			  if (prec >= 0 && prec <= 9 && prec != 8)
			    yyval.ival = prec;
			  else {
			    yyerror(qcmsg[INVALID_PREC]);
			    yyval.ival = NONE;
			  }
			}
    break;

  case 72:
#line 385 "qc.y"
    { yyval.ival = 0; }
    break;

  case 73:
#line 387 "qc.y"
    { yyval.ival = yyvsp[0].ival; }
    break;

  case 78:
#line 398 "qc.y"
    { init_def(); }
    break;

  case 79:
#line 400 "qc.y"
    { debug_info(); rhside = 1; }
    break;

  case 80:
#line 402 "qc.y"
    { definition(yyvsp[-3].xval, yyvsp[0].xval); rhside = 0; }
    break;

  case 83:
#line 410 "qc.y"
    { init_def();
				  if (!(symtb[yyvsp[0].ival].flags & VSYM))
				    yyerror(qcmsg[INVALID_DEF]);
				  else {
				    symtb[yyvsp[0].ival].flags |= DCL;
				    debug_info();
				    definition(funexpr(yyvsp[0].ival), NULL);
				  }
				}
    break;

  case 84:
#line 422 "qc.y"
    { debug_info(); left_hand_side(yyvsp[0].xval); mark(); rhside = 1; }
    break;

  case 85:
#line 424 "qc.y"
    { rhside = 0; }
    break;

  case 86:
#line 427 "qc.y"
    { fix_debug_info(); start_qualifiers(); }
    break;

  case 87:
#line 429 "qc.y"
    { qualifiers(); right_hand_side(yyvsp[-2].xval); }
    break;

  case 88:
#line 431 "qc.y"
    { fix_debug_info(); start_qualifiers(); }
    break;

  case 89:
#line 433 "qc.y"
    { qualifiers(); right_hand_side(yyvsp[-2].xval); }
    break;

  case 91:
#line 438 "qc.y"
    { add_qualifier(yyvsp[0].xval); }
    break;

  case 93:
#line 443 "qc.y"
    { yyval.xval = yyvsp[0].xval; }
    break;

  case 94:
#line 445 "qc.y"
    { yyval.xval = NULL; }
    break;

  case 95:
#line 449 "qc.y"
    { start_where_clauses(); rhside = 0; }
    break;

  case 96:
#line 451 "qc.y"
    { end_where_clauses(); rhside = 1; }
    break;

  case 99:
#line 459 "qc.y"
    { rhside = 1; }
    break;

  case 100:
#line 461 "qc.y"
    { add_where_clause(yyvsp[-3].xval, yyvsp[0].xval); rhside = 0; }
    break;

  case 102:
#line 466 "qc.y"
    { yyval.xval = binexpr(yyvsp[-1].ival, yyvsp[-2].xval, yyvsp[0].xval); }
    break;

  case 104:
#line 471 "qc.y"
    { yyval.xval = binexpr(yyvsp[-1].ival, yyvsp[-2].xval, yyvsp[0].xval); }
    break;

  case 106:
#line 476 "qc.y"
    { yyval.xval = binexpr(yyvsp[-1].ival, yyvsp[-2].xval, yyvsp[0].xval); }
    break;

  case 107:
#line 479 "qc.y"
    { yyval.ival = LEOP; }
    break;

  case 108:
#line 480 "qc.y"
    { yyval.ival = GROP; }
    break;

  case 109:
#line 481 "qc.y"
    { yyval.ival = LEQOP; }
    break;

  case 110:
#line 482 "qc.y"
    { yyval.ival = GEQOP; }
    break;

  case 111:
#line 483 "qc.y"
    { yyval.ival = NEQOP; }
    break;

  case 114:
#line 489 "qc.y"
    { yyval.xval = binexpr(yyvsp[-1].ival, yyvsp[-2].xval, yyvsp[0].xval); }
    break;

  case 115:
#line 492 "qc.y"
    { yyval.ival = SEQOP; }
    break;

  case 118:
#line 498 "qc.y"
    { yyval.xval = binexpr(yyvsp[-1].ival, yyvsp[-2].xval, yyvsp[0].xval); }
    break;

  case 119:
#line 501 "qc.y"
    { yyval.ival = RAPPOP; }
    break;

  case 122:
#line 507 "qc.y"
    { yyval.xval = binexpr(yyvsp[-1].ival, yyvsp[-2].xval, yyvsp[0].xval); }
    break;

  case 123:
#line 510 "qc.y"
    { yyval.ival = LEOP; }
    break;

  case 124:
#line 511 "qc.y"
    { yyval.ival = GROP; }
    break;

  case 125:
#line 512 "qc.y"
    { yyval.ival = EQOP; }
    break;

  case 126:
#line 513 "qc.y"
    { yyval.ival = LEQOP; }
    break;

  case 127:
#line 514 "qc.y"
    { yyval.ival = GEQOP; }
    break;

  case 128:
#line 515 "qc.y"
    { yyval.ival = NEQOP; }
    break;

  case 131:
#line 521 "qc.y"
    { yyval.xval = binexpr(yyvsp[-1].ival, yyvsp[-2].xval, yyvsp[0].xval); }
    break;

  case 132:
#line 523 "qc.y"
    { yyval.xval = binexpr(MINOP, yyvsp[-2].xval, yyvsp[0].xval); }
    break;

  case 133:
#line 526 "qc.y"
    { yyval.ival = ADDOP; }
    break;

  case 134:
#line 527 "qc.y"
    { yyval.ival = CATOP; }
    break;

  case 135:
#line 528 "qc.y"
    { yyval.ival = OROP; }
    break;

  case 136:
#line 529 "qc.y"
    { yyval.ival = ORELSEOP; }
    break;

  case 139:
#line 535 "qc.y"
    { yyval.xval = binexpr(yyvsp[-1].ival, yyvsp[-2].xval, yyvsp[0].xval); }
    break;

  case 140:
#line 538 "qc.y"
    { yyval.ival = MULOP; }
    break;

  case 141:
#line 539 "qc.y"
    { yyval.ival = FDIVOP; }
    break;

  case 142:
#line 540 "qc.y"
    { yyval.ival = DIVOP; }
    break;

  case 143:
#line 541 "qc.y"
    { yyval.ival = MODOP; }
    break;

  case 144:
#line 542 "qc.y"
    { yyval.ival = ANDOP; }
    break;

  case 145:
#line 543 "qc.y"
    { yyval.ival = ANDTHENOP; }
    break;

  case 148:
#line 550 "qc.y"
    { mpz_neg(yyvsp[0].zval, yyvsp[0].zval); yyval.xval = intexpr(yyvsp[0].zval); }
    break;

  case 149:
#line 551 "qc.y"
    { yyval.xval = floatexpr(-yyvsp[0].fval); }
    break;

  case 150:
#line 552 "qc.y"
    { yyval.xval = unexpr(UMINOP, yyvsp[0].xval); }
    break;

  case 151:
#line 553 "qc.y"
    { yyval.xval = unexpr(yyvsp[-1].ival, yyvsp[0].xval); }
    break;

  case 152:
#line 556 "qc.y"
    { yyval.ival = HASHOP; }
    break;

  case 153:
#line 557 "qc.y"
    { yyval.ival = NOTOP; }
    break;

  case 156:
#line 563 "qc.y"
    { yyval.xval = binexpr(yyvsp[-1].ival, yyvsp[-2].xval, yyvsp[0].xval); }
    break;

  case 157:
#line 566 "qc.y"
    { yyval.ival = POWOP; }
    break;

  case 158:
#line 567 "qc.y"
    { yyval.ival = IDXOP; }
    break;

  case 161:
#line 573 "qc.y"
    { yyval.xval = binexpr(yyvsp[-1].ival, yyvsp[-2].xval, yyvsp[0].xval); }
    break;

  case 162:
#line 576 "qc.y"
    { yyval.ival = COMPOP; }
    break;

  case 165:
#line 582 "qc.y"
    { yyval.xval = appexpr(yyvsp[-1].xval, yyvsp[0].xval); }
    break;

  case 166:
#line 585 "qc.y"
    { yyval.ival = QUOTEOP; }
    break;

  case 167:
#line 586 "qc.y"
    { yyval.ival = UNQUOTEOP; }
    break;

  case 168:
#line 587 "qc.y"
    { yyval.ival = FORCEOP; }
    break;

  case 170:
#line 594 "qc.y"
    { yyval.xval = intexpr(yyvsp[0].zval); }
    break;

  case 171:
#line 595 "qc.y"
    { yyval.xval = floatexpr(yyvsp[0].fval); }
    break;

  case 172:
#line 596 "qc.y"
    { yyval.xval = strexpr(yyvsp[0].ival); }
    break;

  case 173:
#line 600 "qc.y"
    { yyval.xval = funexpr(yyvsp[-1].ival); }
    break;

  case 174:
#line 601 "qc.y"
    { yyval.xval = funexpr(yyvsp[0].ival); }
    break;

  case 175:
#line 602 "qc.y"
    { yyval.xval = funexpr(yyvsp[0].ival); }
    break;

  case 176:
#line 603 "qc.y"
    { vartb[yyvsp[0].ival].type = 0;
				  yyval.xval = varexpr(yyvsp[0].ival); }
    break;

  case 177:
#line 605 "qc.y"
    { if (rhside) {
				    yyerror(qcmsg[INVALID_GUARD]);
				    vartb[yyvsp[-2].ival].type = 0;
				    yyval.xval = varexpr(yyvsp[-2].ival);
				  } else {
				    checktype(yyvsp[0].ival);
				    vartb[yyvsp[-2].ival].type = yyvsp[0].ival;
				    yyval.xval = varexpr(yyvsp[-2].ival);
				  }
				}
    break;

  case 178:
#line 619 "qc.y"
    { yyval.xval = unexpr(yyvsp[-1].ival, yyvsp[0].xval); }
    break;

  case 179:
#line 624 "qc.y"
    { yyval.xval = appexpr(funexpr(yyvsp[-1].ival), yyvsp[-2].xval); }
    break;

  case 180:
#line 627 "qc.y"
    { yyval.xval = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr(yyvsp[-2].ival)),
					       yyvsp[-1].xval); }
    break;

  case 181:
#line 632 "qc.y"
    { yyval.xval = appexpr(funexpr(yyvsp[-1].ival), yyvsp[-2].xval); }
    break;

  case 182:
#line 635 "qc.y"
    { yyval.xval = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr(yyvsp[-2].ival)),
					       yyvsp[-1].xval); }
    break;

  case 183:
#line 640 "qc.y"
    { yyval.xval = appexpr(funexpr(yyvsp[-1].ival), yyvsp[-2].xval); }
    break;

  case 184:
#line 643 "qc.y"
    { yyval.xval = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr(yyvsp[-2].ival)),
					       yyvsp[-1].xval); }
    break;

  case 185:
#line 648 "qc.y"
    { yyval.xval = appexpr(funexpr(yyvsp[-1].ival), yyvsp[-2].xval); }
    break;

  case 186:
#line 651 "qc.y"
    { yyval.xval = appexpr(funexpr(MINOP), yyvsp[-2].xval); }
    break;

  case 187:
#line 654 "qc.y"
    { yyval.xval = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr(yyvsp[-2].ival)),
					       yyvsp[-1].xval); }
    break;

  case 188:
#line 659 "qc.y"
    { yyval.xval = appexpr(funexpr(yyvsp[-1].ival), yyvsp[-2].xval); }
    break;

  case 189:
#line 662 "qc.y"
    { yyval.xval = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr(yyvsp[-2].ival)),
					       yyvsp[-1].xval); }
    break;

  case 190:
#line 667 "qc.y"
    { yyval.xval = appexpr(funexpr(yyvsp[-1].ival), yyvsp[-2].xval); }
    break;

  case 191:
#line 670 "qc.y"
    { yyval.xval = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr(yyvsp[-2].ival)),
					       yyvsp[-1].xval); }
    break;

  case 192:
#line 675 "qc.y"
    { yyval.xval = appexpr(funexpr(yyvsp[-1].ival), yyvsp[-2].xval); }
    break;

  case 193:
#line 678 "qc.y"
    { yyval.xval = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr(yyvsp[-2].ival)),
					       yyvsp[-1].xval); }
    break;

  case 194:
#line 685 "qc.y"
    { yyval.xval = funexpr(VOIDOP); }
    break;

  case 195:
#line 695 "qc.y"
    { yyval.xval = yyvsp[-1].xval; }
    break;

  case 196:
#line 697 "qc.y"
    { yyval.xval = pairexpr(yyvsp[-2].xval, funexpr(VOIDOP)); }
    break;

  case 197:
#line 699 "qc.y"
    { yyval.xval = pairexpr(yyvsp[-3].xval, yyvsp[-1].xval); }
    break;

  case 198:
#line 701 "qc.y"
    { yyval.xval = pairexpr(yyvsp[-3].xval,
				  tupleexpr(addexpr(yyvsp[-1].xvval, funexpr(VOIDOP)))); }
    break;

  case 199:
#line 704 "qc.y"
    { yyval.xval = pairexpr(yyvsp[-4].xval,
				  tupleexpr(addexpr(yyvsp[-2].xvval, funexpr(VOIDOP)))); }
    break;

  case 200:
#line 707 "qc.y"
    { yyval.xval = pairexpr(yyvsp[-5].xval,
				  tupleexpr(addexpr(yyvsp[-3].xvval, yyvsp[-1].xval))); }
    break;

  case 201:
#line 713 "qc.y"
    { yyval.xval = funexpr(NILOP); }
    break;

  case 202:
#line 715 "qc.y"
    { yyval.xval = listexpr(
				  addexpr(yyvsp[-1].xvval, funexpr(NILOP))); }
    break;

  case 203:
#line 718 "qc.y"
    { yyval.xval = listexpr(
				  addexpr(yyvsp[-2].xvval, funexpr(NILOP))); }
    break;

  case 204:
#line 721 "qc.y"
    { yyval.xval = listexpr(addexpr(yyvsp[-3].xvval, yyvsp[-1].xval)); }
    break;

  case 205:
#line 723 "qc.y"
    { yyval.xval = appexpr(appexpr(funexpr(ENUMOP),
				  listexpr(addexpr(yyvsp[-3].xvval, funexpr(NILOP)))),
				  yyvsp[-1].xval); }
    break;

  case 206:
#line 729 "qc.y"
    { yyval.xvval = addexpr(exprlist(), yyvsp[0].xval); }
    break;

  case 207:
#line 731 "qc.y"
    { yyval.xvval = addexpr(yyvsp[-2].xvval, yyvsp[0].xval); }
    break;

  case 208:
#line 734 "qc.y"
    { yyval.ival = SEQOP; }
    break;

  case 209:
#line 735 "qc.y"
    { yyval.ival = RAPPOP; }
    break;

  case 210:
#line 736 "qc.y"
    { yyval.ival = LEOP; }
    break;

  case 211:
#line 737 "qc.y"
    { yyval.ival = GROP; }
    break;

  case 212:
#line 738 "qc.y"
    { yyval.ival = EQOP; }
    break;

  case 213:
#line 739 "qc.y"
    { yyval.ival = LEQOP; }
    break;

  case 214:
#line 740 "qc.y"
    { yyval.ival = GEQOP; }
    break;

  case 215:
#line 741 "qc.y"
    { yyval.ival = NEQOP; }
    break;

  case 216:
#line 742 "qc.y"
    { yyval.ival = CATOP; }
    break;

  case 217:
#line 743 "qc.y"
    { yyval.ival = ADDOP; }
    break;

  case 218:
#line 744 "qc.y"
    { yyval.ival = MINOP; }
    break;

  case 219:
#line 745 "qc.y"
    { yyval.ival = OROP; }
    break;

  case 220:
#line 746 "qc.y"
    { yyval.ival = ORELSEOP; }
    break;

  case 221:
#line 747 "qc.y"
    { yyval.ival = MULOP; }
    break;

  case 222:
#line 748 "qc.y"
    { yyval.ival = FDIVOP; }
    break;

  case 223:
#line 749 "qc.y"
    { yyval.ival = DIVOP; }
    break;

  case 224:
#line 750 "qc.y"
    { yyval.ival = MODOP; }
    break;

  case 225:
#line 751 "qc.y"
    { yyval.ival = ANDOP; }
    break;

  case 226:
#line 752 "qc.y"
    { yyval.ival = ANDTHENOP; }
    break;

  case 227:
#line 753 "qc.y"
    { yyval.ival = HASHOP; }
    break;

  case 228:
#line 754 "qc.y"
    { yyval.ival = NOTOP; }
    break;

  case 229:
#line 755 "qc.y"
    { yyval.ival = QUOTEOP; }
    break;

  case 230:
#line 756 "qc.y"
    { yyval.ival = UNQUOTEOP; }
    break;

  case 231:
#line 757 "qc.y"
    { yyval.ival = FORCEOP; }
    break;

  case 232:
#line 758 "qc.y"
    { yyval.ival = POWOP; }
    break;

  case 233:
#line 759 "qc.y"
    { yyval.ival = IDXOP; }
    break;

  case 234:
#line 760 "qc.y"
    { yyval.ival = COMPOP; }
    break;

  case 251:
#line 788 "qc.y"
    { yyval.ival = mkfun(yyvsp[0].sval); }
    break;

  case 252:
#line 790 "qc.y"
    { yyval.ival = mkfun(yyvsp[0].sval); }
    break;

  case 253:
#line 794 "qc.y"
    { yyval.ival = mkfun(yyvsp[0].sval); }
    break;

  case 254:
#line 798 "qc.y"
    { yyval.ival = mkfun(yyvsp[0].sval); }
    break;

  case 255:
#line 802 "qc.y"
    { yyval.ival = mkvar(yyvsp[0].sval); }
    break;

  case 256:
#line 806 "qc.y"
    { yyval.ival = mkfvar(yyvsp[0].sval); }
    break;

  case 257:
#line 808 "qc.y"
    { yyval.ival = mkfvar(yyvsp[0].sval); }
    break;

  case 258:
#line 812 "qc.y"
    { yyval.ival = mkfvar(yyvsp[0].sval); }
    break;

  case 259:
#line 816 "qc.y"
    { yyval.ival = mkfvar(yyvsp[0].sval); }
    break;

  case 260:
#line 819 "qc.y"
    { context = 1; }
    break;

  case 261:
#line 822 "qc.y"
    { context = 0; }
    break;

  case 262:
#line 826 "qc.y"
    { yyval.ival = yyvsp[-1].ival; }
    break;

  case 263:
#line 830 "qc.y"
    { yyval.ival = yyvsp[-1].ival; }
    break;

  case 264:
#line 832 "qc.y"
    { yyval.ival = yyvsp[-1].ival; }
    break;

  case 265:
#line 836 "qc.y"
    { yyval.ival = mktype(yyvsp[-1].sval); }
    break;

  case 266:
#line 838 "qc.y"
    { yyval.ival = mktype(yyvsp[-1].sval); }
    break;

  case 267:
#line 840 "qc.y"
    { yyval.ival = mktype(yyvsp[-1].sval); }
    break;

  case 268:
#line 842 "qc.y"
    { yyval.ival = mktype(yyvsp[-1].sval); }
    break;

  case 269:
#line 846 "qc.y"
    { yyval.ival = mktype(yyvsp[-1].sval); }
    break;

  case 270:
#line 848 "qc.y"
    { yyval.ival = mktype(yyvsp[-1].sval); }
    break;

  case 271:
#line 852 "qc.y"
    { yyval.ival = mktype(yyvsp[-1].sval); }
    break;

  case 272:
#line 854 "qc.y"
    { yyval.ival = mktype(yyvsp[-1].sval); }
    break;


    }

/* Line 991 of yacc.c.  */
#line 2853 "qc.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab2;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:

  /* Suppress GCC warning that yyerrlab1 is unused when no action
     invokes YYERROR.  */
#if defined (__GNUC_MINOR__) && 2093 <= (__GNUC__ * 1000 + __GNUC_MINOR__) \
    && !defined __cplusplus
  __attribute__ ((__unused__))
#endif


  goto yyerrlab2;


/*---------------------------------------------------------------.
| yyerrlab2 -- pop states until the error token can be shifted.  |
`---------------------------------------------------------------*/
yyerrlab2:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 857 "qc.y"


#ifdef YYBISON
#define SYNTAX_ERROR "parse error"
#else
#define SYNTAX_ERROR "syntax error"
#endif

extern int      yyleng, yylineno;
extern char     *source;

yyerror(s)
	char           *s;
{
	fprintf(stderr, "Error %s, line %d: %s", source, yylineno, s);
	if (strcmp(s, SYNTAX_ERROR) == 0)
		if (*yytext)
			fprintf(stderr, " at or near symbol `%s'", yytext);
		else
			fprintf(stderr, " at end of file");
	fprintf(stderr, "\n");
	nerrs++;
}

yywarn(s)
	char           *s;
{
	if (wflag) {
		fprintf(stderr, "Warning %s, line %d: %s\n", source,
			yylineno, s);
		nwarns++;
	}
}

fatal(s)
	char           *s;
{
	if (source && *source)
		fprintf(stderr, "%s: %s: %s -- compilation aborted\n",
			self, source, s);
	else
		fprintf(stderr, "%s: %s -- compilation aborted\n",
			self, s);
	if (codefp) {
		fclose(codefp);
		remove(code);
	}
	exit(1);
}

#define no(n) n, n==1?"":"s"

static
statistics()
{
	int fno, k, n, b, bmax, btotal, n_data;
	for (n = bmax = btotal = k = 0; k < hashtbsz; k++)
		if (hashtb[k] != NONE) {
			n++;
			for (b = -1, fno = hashtb[k]; fno != NONE;
			     b++, fno = symtb[fno].next)
				;
			btotal += b;
			if (b+1>bmax)
				bmax = b+1;
		}
	n_data = strspsz+limbspsz*sizeof(mp_limb_t);
	printf("%d ops in %d module%s, ", codespsz, no(modtbsz));
	printf("%d byte%s data, ", no(n_data));
	printf("%d symbol%s,\n", no(symtbsz));
	printf("%d hash key%s out of %d, %d collision%s, max bucket size = %d\n",
	       no(n), hashtbsz, no(btotal), bmax);
	printf("%d state%s, %d transition%s, %d offset%s\n",
	       no(statetbsz), no(transtbsz), no(roffstbsz));
}

static void *
gmp_allocate (size)
     size_t size;
{
  void *ret;

  ret = malloc (size);
  if (ret == 0) fatal(qcmsg[MEM_OVF]);
  return ret;
}

static void *
gmp_reallocate (oldptr, old_size, new_size)
     void *oldptr;
     size_t old_size;
     size_t new_size;
{
  void *ret;

  ret = realloc (oldptr, new_size);
  if (ret == 0) fatal(qcmsg[MEM_OVF]);
  return ret;
}

static void
gmp_free (blk_ptr, blk_size)
     void *blk_ptr;
     size_t blk_size;
{
  free (blk_ptr);
}

RETSIGTYPE
break_handler()
/* handle SIGINT and SIGTERM */
{
  /* Since many system functions are unsave to call in a signal
     handler, we simply set a flag here; the corresponding actions
     in response to SIGINT (remove code file, close list file,
     terminate program) will be carried out later in a save
     context. */
  int_sig = 1;
  SIGHANDLER_RETURN(0);
}

checkint()
/* check for pending int_sig */
{
  if (int_sig) fatal("interrupt");
}

newrule()
/* reinitialize for the next rule */
{
  rhside = 0; clear(); checkint();
}

newdecl()
/* reinitialize for the next declaration */
{
  flags = PRIV; argv = 0; checkint();
}

precval(z)
     mpz_t z;
/* calculate precedence level */
{
  if (my_mpz_fits_slong_p(z)) {
    long prec = mpz_get_si(z);
    if (prec >= 0 && prec <= 9 && prec != 8)
      return prec;
  }
  yyerror(qcmsg[INVALID_PREC]);
  return NONE;
}

priority(z)
     mpz_t z;
/* set a new priority level */
{
  if (my_mpz_fits_slong_p(z))
    prio = mpz_get_si(z);
  else
    yyerror(qcmsg[INVALID_PRIO]);
}

/* qualifier table */

int qual_size, qual_alloc, clause_size, clause_alloc;
static QUAL *qual;
static CLAUSE *clause;

static void start_qualifiers(void)
{
  qual_size = clause_size = 0;
}

static void qualifiers(void)
{
  int i;
  for (i = qual_size-1; i >= 0; i--)
    if (qual[i].x)
      qualifier(qual[i].x);
    else {
      int j;
      for (j = qual[i].start; j < qual[i].end; j++)
	where_clause(clause[j].l, clause[j].r);
    }
}

static void add_qualifier(EXPR *x)
{
  if (!x) return;
  if (qual_size >= qual_alloc)
    if ((qual = arealloc(qual, qual_alloc, 10, sizeof(QUAL))))
      qual_alloc += 10;
    else
      fatal("memory overflow");
  qual[qual_size++].x = x;
}

static void start_where_clauses(void)
{
  if (qual_size >= qual_alloc)
    if ((qual = arealloc(qual, qual_alloc, 10, sizeof(QUAL))))
      qual_alloc += 10;
    else
      fatal("memory overflow");
  qual[qual_size].x = NULL;
  qual[qual_size].start = clause_size;
}

static void end_where_clauses(void)
{
  qual[qual_size++].end = clause_size;
}

static void add_where_clause(EXPR *l, EXPR *r)
{
  if (clause_size >= clause_alloc)
    if ((clause = arealloc(clause, clause_alloc, 10, sizeof(CLAUSE))))
      clause_alloc += 10;
    else
      fatal("memory overflow");
  clause[clause_size].l = l;
  clause[clause_size].r = r;
  clause_size++;
}

/* expression lists */

static xvect_t *exprlist(void)
{
  xvect_t *v = (xvect_t*)malloc(sizeof(xvect_t));
  if (!v) fatal("memory overflow");
  v->a = v->n = 0;
  v->xv = NULL;
  return v;
}

static xvect_t *addexpr(xvect_t *v, EXPR *x)
{
  if (v->n >= v->a) {
    v->a += 10;
    if (v->xv)
      v->xv = realloc(v->xv, v->a*sizeof(EXPR*));
    else
      v->xv = malloc(v->a*sizeof(EXPR*));
    if (!v->xv) fatal("memory overflow");
  }
  v->xv[v->n++] = x;
  return v;
}

static EXPR *tupleexpr(xvect_t *v)
{
  EXPR *x;
  int n = v->n;
  if (n <= 0) fatal("internal compiler error");
  x = v->xv[--n];
  while (n > 0)
    x = pairexpr(v->xv[--n], x);
  free(v->xv);
  free(v);
  return x;
}

static EXPR *listexpr(xvect_t *v)
{
  EXPR *x;
  int n = v->n;
  if (n <= 0) fatal("internal compiler error");
  x = v->xv[--n];
  while (n > 0)
    x = consexpr(v->xv[--n], x);
  free(v->xv);
  free(v);
  return x;
}

static struct option longopts[] = QC_OPTS;
static struct option all_longopts[] = Q_OPTS;

static int
getintarg(char *s, int *i)
{
  char *t = s;
  while (isspace(*t)) t++;
  s = t;
  while (isdigit(*t)) t++;
  if (t == s) return 0;
  while (isspace(*t)) t++;
  if (*t) return 0;
  *i = atoi(s);
  return 1;
}

static void
parse_opts(argc, argv, pass)
     int argc;
     char **argv;
     int pass; /* 0 denotes source, 1 command line pass */
{
  int c, longind;
  optind = 0;
  while ((c = getopt_long(argc, argv,
			  pass?QC_OPTS1:Q_OPTS1,
			  pass?longopts:all_longopts,
			  &longind)) != EOF)
    switch (c) {
    case QC_NO_PRELUDE:
      prelude = NULL;
      break;
    case QC_PRELUDE:
      prelude = optarg?optarg:prelude;
      break;
    case 'h':
      hflag = 1;
      break;
    case 'l':
      list = optarg?optarg:list;
      break;
    case 'n':
      nflag = 1;
      break;
    case 'o':
      code = optarg?optarg:code;
      break;
    case 'p':
      if (optarg) {
	change_qpath(optarg);
	if (!qpath) fatal("memory overflow");
      }
      break;
    case 't': {
      int sz;
      if (optarg && getintarg(optarg, &sz) && sz > 0)
	hashtbsz = sz;
      else {
	char msg[MAXSTRLEN];
	sprintf(msg, "invalid size `%s'", optarg?optarg:"");
	fatal(msg);
      }
      break;
    }
    case 'v':
      vflag = 1;
      break;
    case 'w':
      wflag = 1;
      break;
    case 'V':
      Vflag = 1;
      break;
    /* interpreter options (ignored): */
    case Q_GNUCLIENT:
    case Q_DEBUG_OPTIONS:
    case Q_BREAK:
    case Q_PROMPT:
    case Q_DEC:
    case Q_HEX:
    case Q_OCT:
    case Q_STD:
    case Q_SCI:
    case Q_FIX:
    case Q_HISTFILE:
    case Q_HISTSIZE:
    case Q_INITRC:
    case Q_NO_INITRC:
    case Q_EXITRC:
    case Q_NO_EXITRC:
    case Q_NO_EDITING:
    case Q_GC_MSGS:
    case Q_GC:
    case Q_STACKSIZE:
    case Q_MEMSIZE:
    case 'd':
    case 'e':
    case 'i':
    case 'q':
    case 'c':
    case 's':
      break;
    default:
      exit(1);
    }
}

static int sargc;
static char **sargv;

static void
get_source_opts(fp)
     FILE *fp;
{
  char s[MAXSTRLEN];
  int i;
  bool first = 1;

  sargc = 1;
  if (!(sargv = aalloc(1, sizeof(char*)))) fatal(qcmsg[MEM_OVF]);
  *sargv = strdup(self);
  while (!feof(fp) && !ferror(fp) &&
	 fgets(s, MAXSTRLEN, fp)) {
    int l = strlen(s);
    if (l > 0 && s[l-1] == '\n') s[l-1] = '\0', l--;
    if (l == 0) {
      first = 0;
      continue;
    } else if (strncmp(s, "#!", 2) == 0)
      if (!first && isspace(s[2])) {
	char *p = s+3;
	while (isspace(*p)) p++;
	sargv = arealloc(sargv, sargc, 1, sizeof(char*));
	sargv[sargc++] = strdup(p);
      } else {
	first = 0;
	continue;
      }
    else
      break;
  }
  sargv = arealloc(sargv, sargc, 1, sizeof(char*));
  sargv[sargc] = NULL;
}

main(argc, argv)
	int             argc;
	char          **argv;
{
	int c, longind;
	char *s;

#ifdef _WIN32
	InstallSignalHandler();
#endif

	/* get program name: */
	self = argv[0];

	/* get environment settings: */
	if ((s = getenv("QPATH")) != NULL)
	  init_qpath(s);
	else
	  init_qpath(QPATH);
	if (!qpath) fatal("memory overflow");

	/* scan command line to obtain the first source file name: */
	opterr = 0;
	while ((c = getopt_long(argc, argv, Q_OPTS1,
				longopts, &longind)) != EOF)
	  ;
	opterr = 1;

	/* get options from the main script: */
	if (argc-optind >= 1) {
	  char fname[MAXSTRLEN];
	  FILE *fp;
	  if (chkfile(searchlib(fname, argv[optind])) &&
	      (fp = fopen(fname, "r")) != NULL) {
	    get_source_opts(fp);
	    fclose(fp);
	    parse_opts(sargc, sargv, 0);
	  }
	}

	/* get command line options: */
	parse_opts(argc, argv, 1);
	argc -= optind, argv += optind;

	if (Vflag) {
		printf(signon, version, sysinfo, year);
		printf(copying);
		printf(helpmsg, self);
		exit(0);
	}
	if (hflag) {
		printf(usage, self);
		sprintf(opts, QC_OPTMSG, QPATH, HASHTBSZ);
		fputs(opts, stdout);
		exit(0);
	}

	/* install break and term handlers: */
	sigint(break_handler);
	sigterm(break_handler);
	sighup(break_handler);

	/* install gmp memory handlers */
	mp_set_memory_functions(gmp_allocate, gmp_reallocate, gmp_free);

	/* set code file id: */
	sprintf(outid, OUTID, version, sysinfo);

	/* compile: */
	if (*list) {
	  FILE *fp;
	  if (!(fp = fopen(list, "w"))) {
	    fprintf(stderr, "%s: error creating %s\n",
		    self, list);
	    exit(1);
	  } else {
	    fclose(fp);
	    freopen(list, "w", stderr);
	  }
	}
	if (!(codefp = fopen(code, "wb"))) {
	  fprintf(stderr, "%s: error creating %s\n",
		  self, code);
	  exit(1);
	}
	mainno = -1;
	write_header();
	inittables();
	if (!initlex(argc, argv))
	  /* empty source; skip parse */
	  goto generate;
	if (yyparse() == 0 && nerrs == 0) {
	generate:
	  if (!nflag) {
	    /* generate code: */
	    write_strsp();
	    write_limbsp();
	    write_hashtb();
	    write_symtb();
	    write_TA();
	    write_matchtb();
	    write_inittb();
	    write_modtb();
	    fix_header();
	  }
	  checkint();
	  if (nflag) {
	    fclose(codefp);
	    remove(code);
	  } else
	    fclose(codefp);
	  if (list && !nwarns) {
	    fclose(stderr);
	    remove(list);
	  }
	  if (vflag)
	    if (nflag)
	      printf("(no code generated)\n");
	    else
	      statistics();
	  exit(0);
	} else {
	  checkint();
	  fclose(codefp);
	  remove(code);
	  if (vflag)
	    putchar('\n');
	  exit(1);
	}
}

